import type { PolygonEncodeChannels, WithDefaultEncode, PlotPolygonEncoderSpec, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { PlotMakType } from './enums';
import { GrammarMarkType } from '@visactor/vgrammar-core';
export declare class PolygonSemanticMark extends SemanticMark<PlotPolygonEncoderSpec, PolygonEncodeChannels> {
    static readonly type = PlotMakType.polygon;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    protected parseScaleOfEncodeX(option: ValueOf<WithDefaultEncode<PlotPolygonEncoderSpec, PolygonEncodeChannels>, PolygonEncodeChannels>): ScaleSpec | Nil;
    parseScaleByEncode(channel: PolygonEncodeChannels, option: ValueOf<WithDefaultEncode<PlotPolygonEncoderSpec, PolygonEncodeChannels>, PolygonEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotPolygonEncoderSpec, PolygonEncodeChannels>): GenerateBaseEncodeSpec<PlotPolygonEncoderSpec>;
}
